#include "words.h"

char allowedchars[256] =
{
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*   ! " # $ % & ' ( ) * + , - . /  */
1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0, /* 0 1 2 3 4 5 6 7 8 9 : ; < = > ?  */
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* @ A B C D E F G H I J K L M N O  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0, /* P Q R S T U V W X Y Z [ \ ] ^ _  */
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* ` a b c d e f g h i j k l m n o  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0, /* p q r s t u v w x y z { | } ~    */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*                  */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1  /*                  */
};

char allowedchars_alphanumeric[256] =
{
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*   ! " # $ % & ' ( ) * + , - . /  */
1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0, /* 0 1 2 3 4 5 6 7 8 9 : ; < = > ?  */
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* @ A B C D E F G H I J K L M N O  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0, /* P Q R S T U V W X Y Z [ \ ] ^ _  */
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* ` a b c d e f g h i j k l m n o  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0, /* p q r s t u v w x y z { | } ~    */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*                  */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1  /*                  */
};

char allowedchars_semicolon[256] =
{
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,0,1,0,0,0,1,1,1,1,0,1,1,1,1,1, /*   ! " # $ % & ' ( ) * + , - . /  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0, /* 0 1 2 3 4 5 6 7 8 9 : ; < = > ?  */
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* @ A B C D E F G H I J K L M N O  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1, /* P Q R S T U V W X Y Z [ \ ] ^ _  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* ` a b c d e f g h i j k l m n o  */
1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0, /* p q r s t u v w x y z { | } ~    */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,1,1,1,0,0,1,0,1,0,0,0,0,1,0, /*                   */
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /*                  */
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1  /*                  */
};

void setAllowedCharacters(char*chars)
{
    memcpy(allowedchars, chars, 256);
}
char* getAllowedCharacters()
{
    return allowedchars;
}

#if 0

static int init()
{
    int c;
    for(c=0;c<256;c++) {
	allowedchars[c] = ((isascii(c) && isalnum(c)) || (c&0xff)==0xe4 || (c&0xff)==0xf6 || (c&0xff)==0xfc || (c&0xff)==0xc4 || (c&0xff)==0xd6 || (c&0xff)==0xdc || (c&0xff)==0xdf);
    }
}

int main()
{
    init();

    int c;
    for(c=0;c<256;c++) {
	if(allowedchars[c])
	    printf("1,");
	else
	    printf("0,");
	if((c&15) == 15) {
	    int s;
	    if(c>=32 && (c<128 || c>0xa0)) {
		printf(" /* ");
		for(s=(c&0xf0);s<=(c|0x0f);s++) {
		    printf("%c ", s);
		}
		printf(" */");
	    }
	    printf("\n");
	}
    }
}
#endif
